; Source created with Parsic Version 3.x

; at              : 16/08/02 17.01.31


; Project File    : c:\PROGRA~1\PARSIC\IMPIAN~1\POMPAESA.PIC

; Project Version : 1.0.10

; Created         : 16/08/02 16.25.00

; Last change     : 16/08/02 17.01.26

	PROCESSOR 12C671

	INCLUDE P12C671.INC

	RADIX DEC


	__IDLOCS H'0100'

	__CONFIG _CP_ALL & _PWRTE_ON & _WDT_ON & _INTRC_OSC & _MCLRE_OFF

; Diverses

ZERO	EQU Z	; ZERO-Flag
CARRY	 EQU C	; CARRY-Flag


; Variable

ZR1	= 32	; located in Bank 0
ZR1_FD	= 33	; located in Bank 0
S0	= 34	; located in Bank 0
OS1_FD	= 35	; located in Bank 0
GP	= 36	; located in Bank 0
ZV1	= 37	; located in Bank 0
ZV1_HI	= 38	; located in Bank 0
ZV1_FD	= 39	; located in Bank 0
TR1	= 40	; located in Bank 0
TR1_HI	= 41	; located in Bank 0
S1	= 42	; located in Bank 0
ZV2	= 43	; located in Bank 0
ZV2_HI	= 44	; located in Bank 0
ZV2_FD	= 45	; located in Bank 0
RAM	= 46	; located in Bank 0
SYS_WSAV	= 112	; located in Bank 0, 1
SYS_SSAV	= 113	; located in Bank 0, 1

	ERRORLEVEL -302	; disable warning (Bankswitching)
	ERRORLEVEL -306	; disable warning (Pageswitching)

;****************************************
;Programmanfang
;****************************************

	ORG 0

	MOVWF H'70'
	GOTO SYS_INIT
	NOP
	NOP

;****************************************
;Interrupt-Adress
;****************************************

	MOVWF SYS_WSAV	; save register
	SWAPF STATUS,W
	CLRF STATUS	; bank 0
	MOVWF SYS_SSAV

	BCF INTCON,T0IF	; Interrupt quitieren

	BCF STATUS,RP0	; Bank 0
	INCFSZ TR1,F
	GOTO SYS_INT_LABEL_0
	INCF TR1_HI,F

SYS_INT_LABEL_0

EXITINT

	SWAPF SYS_SSAV,W	; Register zurck
	MOVWF STATUS
	SWAPF SYS_WSAV,F
	SWAPF SYS_WSAV,W

	RETFIE	; RETurn From Interrupt and Enable GIE


;****************************************
; Subroutines
;****************************************


;****************************************
;Initialisierung
;****************************************


SYS_INIT

	BSF STATUS,RP0	; Bank 1
	MOVFW H'70'
	MOVWF OSCCAL
	MOVLW B'00100000'
	MOVWF INTCON

; Ausgangs-Pegel setzen, bevor die Richtung gesetzt wird

	BCF STATUS,RP0	; Bank 0
	MOVLW B'00000000'
	MOVWF GPIO

	MOVLW 143
	BSF STATUS,RP0	; Bank 1
	MOVWF OPTION_REG

	MOVLW 7	; all digital
	MOVWF ADCON1

; Richtung setzen

	MOVLW B'11001111'
	MOVWF TRISIO

; init vars


; Clear RAM

	MOVLW 32
	MOVWF FSR
CR1
	CLRF INDF
	INCF FSR,F
	BTFSS FSR,7
	GOTO CR1
	BSF FSR,5
CR2
	CLRF INDF
	INCF FSR,F
	MOVLW H'C0'
	SUBWF FSR,W
	BTFSS STATUS,ZERO
	GOTO CR2


	BCF STATUS,RP0	; Bank 0
	CLRF TMR0
	BCF INTCON,T0IF
	BSF INTCON,GIE	; Interrupt freigeben

;**********************************
;******* Haupt-Programm ***********
;**********************************

MAIN

	CLRWDT

;***************************************************
; Zhler -> ZR1
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BTFSS S0,0	; Reset ?
	GOTO LABEL_ZR1_COUNT
	CLRF ZR1
	GOTO LABEL_ZR1_SETOUT

LABEL_ZR1_COUNT

; Test auf positive Flanke

	BCF STATUS,RP0	; Bank 0
	BTFSC ZR1_FD,0
	GOTO LABEL_ZR1_SETFD
	BTFSS S0,1
	GOTO LABEL_ZR1_SETFD

	INCF ZR1,F

LABEL_ZR1_SETOUT

; Output Q0

	BTFSS ZR1,0
	GOTO LABEL_ZR1_SETOUT0
	BSF S0,2
	GOTO LABEL_ZR1_SETOUT0_END
LABEL_ZR1_SETOUT0
	BCF S0,2
LABEL_ZR1_SETOUT0_END

LABEL_ZR1_SETFD

	BCF STATUS,RP0	; Bank 0
	BTFSS S0,1
	GOTO LABEL_ZR1_SETFD2
	BSF ZR1_FD,0
	GOTO LABEL_ZR1_END
LABEL_ZR1_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF ZR1_FD,0
LABEL_ZR1_END

;***************************************************
; GND
;***************************************************

	BCF S0,0	; immer Low

;***************************************************
; One Shot -> OS1
;***************************************************


	BTFSS GPIO,0
	GOTO LABEL_OS1_1
	BTFSC OS1_FD,0
	GOTO LABEL_OS1_1
	BSF OS1_FD,0
	BSF S0,1
	GOTO LABEL_OS1_2
LABEL_OS1_1
	BCF STATUS,RP0	; Bank 0
	BCF S0,1
	BTFSC GPIO,0
	GOTO LABEL_OS1_2
	BCF OS1_FD,0
LABEL_OS1_2
;***************************************************
; ODER - Gatter -> LG1
;***************************************************

LABEL_LG1_1
	BCF STATUS,RP0	; Bank 0
	BTFSC GPIO,1
	GOTO LABEL_LG1_TRUE
LABEL_LG1_2
	BTFSC GPIO,2
	GOTO LABEL_LG1_TRUE

LABEL_LG1_FALSE
	BCF S0,3
	GOTO LABEL_LG1_ENDE
LABEL_LG1_TRUE
	BCF STATUS,RP0	; Bank 0
	BSF S0,3
LABEL_LG1_ENDE
;***************************************************
; ODER - Gatter -> LG2
;***************************************************

LABEL_LG2_1
	BTFSC S0,2
	GOTO LABEL_LG2_TRUE
LABEL_LG2_2
	BTFSC S0,3
	GOTO LABEL_LG2_TRUE
LABEL_LG2_3
	BTFSC GPIO,4
	GOTO LABEL_LG2_TRUE

LABEL_LG2_FALSE
	BCF GPIO,5
	GOTO LABEL_LG2_ENDE
LABEL_LG2_TRUE
	BCF STATUS,RP0	; Bank 0
	BSF GPIO,5
LABEL_LG2_ENDE
;***************************************************
; Zhler -> ZV1
;***************************************************

	BTFSS GPIO,4	; Reset ?
	GOTO LABEL_ZV1_COUNT
	CLRF ZV1
	CLRF ZV1_HI
	GOTO LABEL_ZV1_SETOUT

LABEL_ZV1_COUNT

; Test auf positive Flanke

	BCF STATUS,RP0	; Bank 0
	BTFSS S0,4
	GOTO LABEL_ZV1_SETFD
	BTFSC ZV1_FD,0
	GOTO LABEL_ZV1_SETFD

	BSF ZV1_FD,0


	BTFSC S0,6	; Vorwrts oder Rckwrts ?
	GOTO LABEL_ZV1_BACKWARD

	INCFSZ ZV1,F
	GOTO LABEL_ZV1_SETOUT
	INCF ZV1_HI,F
	GOTO LABEL_ZV1_SETOUT

LABEL_ZV1_BACKWARD
	BCF STATUS,RP0	; Bank 0
	DECF ZV1,F
	INCFSZ ZV1,W
	GOTO LABEL_ZV1_SETOUT
	DECF ZV1_HI,F

LABEL_ZV1_SETOUT


LABEL_ZV1_SETFD

; Test auf negative Flanke

	BCF STATUS,RP0	; Bank 0
	BTFSC S0,4
	GOTO LABEL_ZV1_EXIT
	BCF ZV1_FD,0

LABEL_ZV1_EXIT

;***************************************************
; Timer -> TR1
;***************************************************

	MOVLW 7	; Test auf >=
	SUBWF TR1_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR1_CHECK
	MOVLW 161
	SUBWF TR1,W	;F-W -> W
LABEL_TR1_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR1_ENDE

LABEL_TR1_RESET
	MOVLW 7	; Test auf >=
	SUBWF TR1_HI,F	;F-W -> F
	MOVLW 161
	SUBWF TR1,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR1_HI,F

LABEL_TR1_SET	; toggel output
	BTFSC S0,5
	GOTO LABEL_TR1_CLR
	BSF S0,5
	GOTO LABEL_TR1_ENDE
LABEL_TR1_CLR
	BCF S0,5
LABEL_TR1_ENDE

;***************************************************
; UND - Gatter -> LG3
;***************************************************

LABEL_LG3_1
	BCF STATUS,RP0	; Bank 0
	BTFSS S0,5
	GOTO LABEL_LG3_FALSE
LABEL_LG3_2
	BTFSS GPIO,3
	GOTO LABEL_LG3_FALSE

LABEL_LG3_TRUE
	BSF S0,4
	GOTO LABEL_LG3_ENDE
LABEL_LG3_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF S0,4
LABEL_LG3_ENDE
;***************************************************
; GND
;***************************************************

	BCF S0,6	; immer Low

;***************************************************
; Vergleich -> IF1
;***************************************************

	MOVLW HIGH 43200
	SUBWF ZV1_HI,W	; F - W -> W

	BTFSS STATUS,ZERO	; Wenn ZERO gesetzt LOW-Byte testen
	GOTO LABEL_IF1_CHECK
	MOVLW LOW 43200
	SUBWF ZV1,W	; F - W -> W

LABEL_IF1_CHECK
	BCF STATUS,RP0	; Bank 0
	BTFSS STATUS,ZERO	; Test auf -> =
	GOTO LABEL_IF1_FALSE

LABEL_IF1_TRUE
	BSF S0,7
	GOTO LABEL_IF1_EXIT

LABEL_IF1_FALSE
	BCF S0,7

LABEL_IF1_EXIT
;***************************************************
; RS-FLIP-FLOP -> RS1
;***************************************************

	BTFSC S1,1
	GOTO LABEL_RS1_RESET
	BTFSS S0,7
	GOTO LABEL_RS1_ENDE
	BSF GPIO,4	; Ausgang setzen
	GOTO LABEL_RS1_ENDE
LABEL_RS1_RESET
	BCF STATUS,RP0	; Bank 0
	BCF GPIO,4	; Ausgang zurcksetzen
LABEL_RS1_ENDE

;***************************************************
; UND - Gatter -> LG4
;***************************************************

LABEL_LG4_1
	BCF STATUS,RP0	; Bank 0
	BTFSS S0,5
	GOTO LABEL_LG4_FALSE
LABEL_LG4_2
	BTFSS GPIO,4
	GOTO LABEL_LG4_FALSE

LABEL_LG4_TRUE
	BSF S1,0
	GOTO LABEL_LG4_ENDE
LABEL_LG4_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF S1,0
LABEL_LG4_ENDE
;***************************************************
; Zhler -> ZV2
;***************************************************

	BTFSS S1,1	; Reset ?
	GOTO LABEL_ZV2_COUNT
	CLRF ZV2
	CLRF ZV2_HI
	GOTO LABEL_ZV2_SETOUT

LABEL_ZV2_COUNT

; Test auf positive Flanke

	BCF STATUS,RP0	; Bank 0
	BTFSS S1,0
	GOTO LABEL_ZV2_SETFD
	BTFSC ZV2_FD,0
	GOTO LABEL_ZV2_SETFD

	BSF ZV2_FD,0


	BTFSC S1,2	; Vorwrts oder Rckwrts ?
	GOTO LABEL_ZV2_BACKWARD

	INCFSZ ZV2,F
	GOTO LABEL_ZV2_SETOUT
	INCF ZV2_HI,F
	GOTO LABEL_ZV2_SETOUT

LABEL_ZV2_BACKWARD
	BCF STATUS,RP0	; Bank 0
	DECF ZV2,F
	INCFSZ ZV2,W
	GOTO LABEL_ZV2_SETOUT
	DECF ZV2_HI,F

LABEL_ZV2_SETOUT


LABEL_ZV2_SETFD

; Test auf negative Flanke

	BCF STATUS,RP0	; Bank 0
	BTFSC S1,0
	GOTO LABEL_ZV2_EXIT
	BCF ZV2_FD,0

LABEL_ZV2_EXIT

;***************************************************
; Vergleich -> IF2
;***************************************************

	MOVLW 1200
	SUBWF ZV2,W	; F - W -> W

LABEL_IF2_CHECK
	BCF STATUS,RP0	; Bank 0
	BTFSS STATUS,CARRY	; Test auf -> >
	GOTO LABEL_IF2_FALSE
	BTFSC STATUS,ZERO
	GOTO LABEL_IF2_FALSE

LABEL_IF2_TRUE
	BSF S1,1
	GOTO LABEL_IF2_EXIT

LABEL_IF2_FALSE
	BCF S1,1

LABEL_IF2_EXIT
;***************************************************
; GND
;***************************************************

	BCF S1,2	; immer Low

;****************************************

	GOTO MAIN

	ORG 1023

	MOVLW H'00'	; OSCCAL

	END

